<?php 

require 'ARlib.inc'; 

function get($gateway)
{
    $url = "http://" . $gateway . "/gw/rest/V1/?method=gw.getWSDL";
    $proxy = new SoapClient($url);

    $nodes = $proxy->metadataGet(DEFAULTADDR,"name");
    $numnodes = count($nodes);
    echo "Sensor Net Server: $server $numnodes nodes in network. \n";

    // inet provides mappings from EUIDs to IP addresses
    $inets = $proxy->inetDump(); // timestamp is heatbeat

    // AddrCache provides mappings from EUIDs to short addresses
    $addrcache = $proxy->addrcacheDump("*");

    foreach($nodes as $node) {
      $ip    = EUIDtoIPv4($inets, $node->addr);
      $short = EUIDtoAddr($addrcache, $node->addr);

      echo "Name: $node->value \n";
      echo "IP addr: $ip \n";
      echo "EUID: $node->addr \n";
      echo "Short Addr: $short \n";
      echo "\n";
    }

}

if ($argc != 2) {
    echo "Usage: php nodes.php gateway\n";
    exit(3);
}
$gateway = $argv[1];
get($gateway);

?>
