<?php

define("TIMEOUT", 2.0);
define ("DEFAULTADDR", 'FFFFFFFFFFFFFFFF');

function EUIDtoAddr($addrMaps, $euid){
  foreach($addrMaps as $map) {
    if ($map->longAddr == $euid) return $map->shortAddr;
  }
  return NULL;
}

function rpc_execute($proxy, $source_euid, $dest_short, $testId, $runId)
{
    $ret = $proxy->rpcExecuteconnectivityTestStart(
        $source_euid,
        10.0, // timeout
        "*",  // bridge address
        $runId,  // runId
        $testId, // testId
        $dest_short,  // destination
        4,   // numPackets
        1000);  // sendInterval in ms

    foreach ($ret as $result) {
        echo "Mote " . $result->addr .
             " Time " . $result->timestamp ."\n";
    }
}

function iterate_node($gateway)
{
    $url = "http://" . $gateway . "/gw/rest/V1/?method=gw.getWSDL";
    $proxy = new SoapClient($url);

    $nodes = $proxy->metadataGet(DEFAULTADDR, "name");
    // AddrCache provides mappings from EUIDs to short addresses
    $addrcache = $proxy->addrcacheDump("*");

    $testId = rand(1,65535);
    $runId = 1;
    
    foreach($nodes as $node) {
        $nodes_inner = $proxy->metadataGet(DEFAULTADDR, "name");
        $node_short  = EUIDtoAddr($addrcache, $node->addr);

        foreach($nodes_inner as $node_inner) {
            if ($node_inner->addr != $node->addr) {
                $destination = EUIDtoAddr($addrcache, $node_inner->addr);
                if ($node_short != NULL && $destination != NULL) {
                    echo "Surveying link from $node->addr to $destination.\n";

                    // do the survey for the given source and destination.
                    rpc_execute($proxy, $node->addr, $destination, 
                                $testId, $runId);

                    // increase the runId to differentiate next survey
                    $runId = $runId + 1;
                }
            }
        }
    }
}

if ($argc != 1 && $argc != 2) {
    echo "Usage: php rpc_connectivity_test_start.php gateway \n";
    exit(3);
}
$gateway = $argv[1];
iterate_node($gateway);

?>
