<?php

function slurp($gateway, $date)
{
    $url = "http://" . $gateway . "/gw/rest/V1/?method=gw.getWSDL";
    $proxy = new SoapClient($url);
    $fields = split("-", $date);
    $year = $fields[0];
    $month = $fields[1];
    $day = $fields[2];
    $t1 = mktime(0, 0, 0, $month, $day, $year, -1);
    $t2 = $t1 + 86400;

    $offset = 0;
    while (1) {
        $ret = $proxy->eventsRead($t1, $t2, "*", "ffffffffffffffff", $offset);
        foreach ($ret->results as $result) { 
            $value = $result->value;
            print_event($result->addr, $result->timestamp, $value);
        }
        if (($ret->offset + count($ret->results)) == $ret->total)
            break;
        else
            $offset += count($ret->results);
    }
}

function print_event($addr, $timestamp, $value)
{
    $datestr = date("Y-m-d H:m:s", $timestamp);
    if ($value->name == "TemperatureReadEvent") {
        echo $datestr . " mote " . $addr . "\n";
        echo "  TemperatureReadEvent value : ".
            $value->{$value->name} . "\n\n";
    }
    else if ($value->name == "NodeStatsEvent") {
        echo $datestr . " mote " . $addr . "\n";
        echo "  NodeStatsEvent link_sent : " . 
            $value->{$value->name}->{"link_sent"} . " packets\n";
        echo "  NodeStatsEvent link_received : " . 
            $value->{$value->name}->{"link_received"} . " packets\n\n";
    }
}

if ($argc != 3) {
    echo "Usage: php slurp.php gateway date\n";
    exit(3);
}
$gateway = $argv[1];
$date =$argv[2];
slurp($gateway, $date);

?>
