<?php

function watch($gateway, $delta)
{
    $url = "http://" . $gateway . "/gw/rest/V1/?method=gw.getWSDL";
    $proxy = new SoapClient($url);

    $ret = $proxy->gwGetStatus();
    $t1 = $ret->timestamp;
    while (1) {
        sleep($delta);
        $t2 = 2147483647;
        $events = readEvents($proxy, $t1, $t2, "*", "ffffffffffffffff");
        if (count($events) > 0) {
            processEvents($events);
            # Prepare for next [t1,t2). "+ epsilon" to handle boundary
            $epsilon = 0.00001;
            $t1 = $events[count($events) - 1]->timestamp + $epsilon;
        }
    }
}

function readEvents($proxy, $t1, $t2, $name, $addr)
{
    $events = array();
    $offset = 0;
    while (1) {
        $ret = $proxy->eventsRead($t1, $t2, "*", "ffffffffffffffff", $offset);
        foreach ($ret->results as $result) { 
            $events[] = $result;
        }
        if (($ret->offset + count($ret->results)) == $ret->total)
            break;
        else
            $offset += count($ret->results);
    }
    return $events;
}

function processEvents($events)
{
    foreach ($events as $event) {
        $name = $event->value->name;
        print $event->addr . 
              " " .  
              $event->timestamp . 
              " " . 
              $name . 
              " " . 
              $event->value->{$name} . 
              "\n";
        # doSomething($event)        
    }
}

if ($argc != 3) {
    echo "Usage: php watch.php gateway delta\n";
    exit(3);
}
$gateway = $argv[1];
$delta = $argv[2];
watch($gateway, $delta);

?>
